Index: issm/trunk/src/modules/Scotch/Scotch.cpp
===================================================================
--- issm/trunk/src/modules/Scotch/Scotch.cpp	(revision 12709)
+++ issm/trunk/src/modules/Scotch/Scotch.cpp	(revision 13395)
@@ -8,22 +8,16 @@
 #error "Cannot compile with HAVE_CONFIG_H symbol! run configure first!"
 #endif
-
-
 #include "./Scotch.h"
 
-/******************************/
-/*                            */
-/* This is the main function. */
-/*                            */
-/******************************/
-
-void mexFunction( int nlhs,
-				  mxArray *plhs[],
-				  int nrhs,
-				  const mxArray *prhs[] )
-{
-
-#ifndef _HAVE_SCOTCH_ //only works if scotch library has been compiled in.
-	_error2_("Scotch not available! Cannot carry out Scotch partitioning!");
+void GmapUsage(void){/*{{{*/
+	mexPrintf("\n");
+	mexPrintf("Usage: [maptab]=Scotch(adjmat,vertlb,vertwt,edgewt,archtyp,archpar,\n");
+	mexPrintf("                         Scotch-specific parameters);\n");
+	mexPrintf("\n");
+}/*}}}*/
+void mexFunction( int nlhs, mxArray *plhs[], int nrhs, const mxArray *prhs[]){
+
+	#ifndef _HAVE_SCOTCH_ //only works if scotch library has been compiled in.
+	_error_("Scotch not available! Cannot carry out Scotch partitioning!");
 	#else
 
@@ -42,5 +36,5 @@
 	/* Check for proper number of arguments */
    
-	if      (nrhs == 0 && nlhs == 0) {
+	if (nrhs == 0 && nlhs == 0) {
 		GmapUsage();
 		return;
@@ -254,14 +248,2 @@
 #endif //#ifndef _HAVE_SCOTCH_
 }
-
-void GmapUsage( void )
-{
-
-    mexPrintf("\n");
-    mexPrintf("Usage: [maptab]=Scotch(adjmat,vertlb,vertwt,edgewt,archtyp,archpar,\n");
-    mexPrintf("                         Scotch-specific parameters);\n");
-    mexPrintf("\n");
-
-    return;
-}
-
Index: issm/trunk/src/modules/Scotch/Scotch.h
===================================================================
--- issm/trunk/src/modules/Scotch/Scotch.h	(revision 12709)
+++ issm/trunk/src/modules/Scotch/Scotch.h	(revision 13395)
@@ -6,11 +6,7 @@
 #define _SCOTCH_H
 
-/* local prototypes: */
-void GmapUsage(void);
-
 #include <stdio.h>
 #include <string.h>    /*  strcasecmp  */
 #include <time.h>      /*  clock,time,difftime  */
-
 #include "../../c/include/globals.h"
 #include "../../c/modules/modules.h"
@@ -24,17 +20,16 @@
 /*  Scotch structures and prototypes  */
 #ifdef MATLAB
-		#include "mat.h"
-		#include "mex.h"
-		#include "matrix.h"
+#include "mat.h"
+#include "mex.h"
+#include "matrix.h"
 
-		#define printf mexPrintf
-		#define fprintf(file,...) (file == stdout || file == stderr ? mexPrintf(__VA_ARGS__) : fprintf(file,__VA_ARGS__))
-		#define malloc mxMalloc
-		#define calloc mxCalloc
-		#define realloc mxRealloc
-		#define free mxFree
-		#define exit(status) mexErrMsgTxt("exit=" #status)
+#define printf mexPrintf
+#define fprintf(file,...) (file == stdout || file == stderr ? mexPrintf(__VA_ARGS__) : fprintf(file,__VA_ARGS__))
+#define malloc mxMalloc
+#define calloc mxCalloc
+#define realloc mxRealloc
+#define free mxFree
+#define exit(status) mexErrMsgTxt("exit=" #status)
 #endif
 
-
 #endif  /* _SCOTCH_H */
Index: issm/trunk/src/modules/Shp2Kml/Shp2Kml.cpp
===================================================================
--- issm/trunk/src/modules/Shp2Kml/Shp2Kml.cpp	(revision 12709)
+++ issm/trunk/src/modules/Shp2Kml/Shp2Kml.cpp	(revision 13395)
@@ -11,70 +11,5 @@
 #include "./Shp2Kml.h"
 
-void mexFunction( int nlhs, mxArray* plhs[], int nrhs, const mxArray* prhs[]){
-
-	int i,verbose=1;
-
-	/*input: */
-	char    *filshp=NULL,*filkml=NULL;
-	int     sgn;
-	Options* options=NULL;
-	double   cm=0.,sp=0.;
-
-	/* output: */
-	int     iret=0;
-
-	#ifndef _HAVE_SHAPELIB_ //only works if shapelib library has been compiled in.
-	_error2_("Shapelib not available! Cannot carry out shp file translation!");
-	#endif
-
-	/*Boot module: */
-	MODULEBOOT();
-
-	/*checks on arguments on the matlab side: */
-	if (nlhs > NLHS) {
-		Shp2KmlUsage(); _error2_("Shp2Kml usage error");
-	}
-	if (nrhs < NRHS) {
-		Shp2KmlUsage(); _error2_("Shp2Kml usage error");
-	}
-
-	/*Input datasets: */
-	FetchData(&filshp,SHP_IN);
-	FetchData(&filkml,KML_IN);
-	FetchData(&sgn,SGN_IN);
-	FetchData(&options,NRHS,nrhs,prhs);
-
-	/*  defaults are in Xy2lldef, so don't duplicate them here, and only use user values if both have been specified  */
-	if (options->GetOption("central_meridian") || options->GetOption("standard_parallel")) {
-		options->Get(&cm,"central_meridian");
-		if (verbose) _printLine_("  cm=" << cm);
-		options->Get(&sp,"standard_parallel");
-		if (verbose) _printLine_("  sp=" << sp);
-	}
-
-	/*some checks*/
-	if (sgn < -1 || sgn > +1) _error2_("Hemisphere sgn=" << sgn << " must be +1 (north), -1 (south), or 0 (no translation).");
-	if (fabs(cm)      > 180.) _error2_("Central meridian cm=" << cm << " must be between -180 (west) and +180 (east) degrees.");
-	if (sp < 0. || sp >  90.) _error2_("Standard parallel sp=" << sp << " must be between 0 and 90 degrees (in specified hemisphere).");
-
-	/* Run core computations: */
-	if (options->GetOption("central_meridian") && options->GetOption("standard_parallel"))
-		iret=Shp2Kmlx(filshp,filkml,sgn,cm,sp);
-	else
-		iret=Shp2Kmlx(filshp,filkml,sgn);
-
-	/*Write data: */
-	WriteData(RET_OUT,iret);
-
-	/*Clean-up*/
-	delete options;
-	xfree((void**)&filkml);
-	xfree((void**)&filshp);
-
-	/*end module: */
-	MODULEEND();
-}
-
-void Shp2KmlUsage(void){
+void Shp2KmlUsage(void){/*{{{*/
 	_pprintLine_("Shp2Kml - shp to kml file conversion module:");
 	_pprintLine_("");
@@ -98,3 +33,67 @@
 	_pprintLine_("      [ret]=Shp2Kml('file.shp','file.kml',-1,'central_meridian', 0,'standard_parallel',71);");
 	_pprintLine_("");
+}/*}}}*/
+WRAPPER(Shp2Kml){
+
+	int i,verbose=1;
+
+	/*input: */
+	char    *filshp=NULL,*filkml=NULL;
+	int     sgn;
+	Options* options=NULL;
+	double   cm=0.,sp=0.;
+
+	/* output: */
+	int     iret=0;
+
+	#ifndef _HAVE_SHAPELIB_ //only works if shapelib library has been compiled in.
+	_error_("Shapelib not available! Cannot carry out shp file translation!");
+	#endif
+
+	/*Boot module: */
+	MODULEBOOT();
+
+	/*checks on arguments on the matlab side: */
+	if (nlhs > NLHS) {
+		Shp2KmlUsage(); _error_("Shp2Kml usage error");
+	}
+	if (nrhs < NRHS) {
+		Shp2KmlUsage(); _error_("Shp2Kml usage error");
+	}
+
+	/*Input datasets: */
+	FetchData(&filshp,SHP_IN);
+	FetchData(&filkml,KML_IN);
+	FetchData(&sgn,SGN_IN);
+	FetchData(&options,NRHS,nrhs,prhs);
+
+	/*  defaults are in Xy2lldef, so don't duplicate them here, and only use user values if both have been specified  */
+	if (options->GetOption("central_meridian") || options->GetOption("standard_parallel")) {
+		options->Get(&cm,"central_meridian");
+		if (verbose) _printLine_("  cm=" << cm);
+		options->Get(&sp,"standard_parallel");
+		if (verbose) _printLine_("  sp=" << sp);
+	}
+
+	/*some checks*/
+	if (sgn < -1 || sgn > +1) _error_("Hemisphere sgn=" << sgn << " must be +1 (north), -1 (south), or 0 (no translation).");
+	if (fabs(cm)      > 180.) _error_("Central meridian cm=" << cm << " must be between -180 (west) and +180 (east) degrees.");
+	if (sp < 0. || sp >  90.) _error_("Standard parallel sp=" << sp << " must be between 0 and 90 degrees (in specified hemisphere).");
+
+	/* Run core computations: */
+	if (options->GetOption("central_meridian") && options->GetOption("standard_parallel"))
+		iret=Shp2Kmlx(filshp,filkml,sgn,cm,sp);
+	else
+		iret=Shp2Kmlx(filshp,filkml,sgn);
+
+	/*Write data: */
+	WriteData(RET_OUT,iret);
+
+	/*Clean-up*/
+	delete options;
+	xDelete<char>(filkml);
+	xDelete<char>(filshp);
+
+	/*end module: */
+	MODULEEND();
 }
Index: issm/trunk/src/modules/Shp2Kml/Shp2Kml.h
===================================================================
--- issm/trunk/src/modules/Shp2Kml/Shp2Kml.h	(revision 12709)
+++ issm/trunk/src/modules/Shp2Kml/Shp2Kml.h	(revision 13395)
@@ -6,6 +6,14 @@
 #define _SHP2KML_H
 
-/* local prototypes: */
-void Shp2KmlUsage(void);
+#ifdef HAVE_CONFIG_H
+	#include <config.h>
+#else
+	#error "Cannot compile with HAVE_CONFIG_H symbol! run configure first!"
+#endif
+
+/*For python modules: needs to come before header files inclusion*/
+#ifdef _HAVE_PYTHON_
+#define PY_ARRAY_UNIQUE_SYMBOL PythonIOSymbol
+#endif
 
 #include "../../c/include/globals.h"
@@ -18,12 +26,21 @@
 #define __FUNCT__  "Shp2Kml"
 
+#ifdef _HAVE_MATLAB_MODULES_
+/* serial input macros: */
+#define SHP_IN  prhs[0]
+#define KML_IN  prhs[1]
+#define SGN_IN  prhs[2]
+/* serial output macros: */
+#define RET_OUT (mxArray**)&plhs[0]
+#endif
 
+#ifdef _HAVE_PYTHON_MODULES_
 /* serial input macros: */
-#define SHP_IN    prhs[0]
-#define KML_IN    prhs[1]
-#define SGN_IN    prhs[2]
-
+#define SHP_IN PyTuple_GetItem(args,0)
+#define KML_IN PyTuple_GetItem(args,1)
+#define SGN_IN PyTuple_GetItem(args,2)
 /* serial output macros: */
-#define RET_OUT    (mxArray**)&plhs[0]
+#define RET_OUT output,0
+#endif
 
 /* serial arg counts: */
Index: issm/trunk/src/modules/StringToEnum/StringToEnum.cpp
===================================================================
--- issm/trunk/src/modules/StringToEnum/StringToEnum.cpp	(revision 12709)
+++ issm/trunk/src/modules/StringToEnum/StringToEnum.cpp	(revision 13395)
@@ -5,13 +5,19 @@
 #include "./StringToEnum.h"
 
-void mexFunction( int nlhs, mxArray* plhs[], int nrhs, const mxArray* prhs[]){
+void StringToEnumUsage(void){/*{{{*/
+	_pprintLine_("");
+	_pprintLine_("   usage: " << __FUNCT__ << "enum = StringToEnum(string);");
+	_pprintLine_("");
+}/*}}}*/
+WRAPPER(StringToEnum){
 
 	char    *name    = NULL;
 	int      enum_out;
 
-	/*checks on arguments on the matlab side: */
-	if(nrhs!=NRHS){
-		StringToEnumUsage(); _error2_("usage. See above");
-	}
+	/*Boot module: */
+	MODULEBOOT();
+
+	/*checks on arguments: */
+	CHECKARGUMENTS(NLHS,NRHS,&StringToEnumUsage);
 
 	/*Fetch inputs: */
@@ -23,10 +29,6 @@
 	/* output: */
 	WriteData(ENUMOUT,enum_out);
+
+	/*end module: */
+	MODULEEND();
 }
-
-void StringToEnumUsage(void)
-{
-	_pprintLine_("");
-	_pprintLine_("   usage: " << __FUNCT__ << "enum = StringToEnum(string);");
-	_pprintLine_("");
-}
Index: issm/trunk/src/modules/StringToEnum/StringToEnum.h
===================================================================
--- issm/trunk/src/modules/StringToEnum/StringToEnum.h	(revision 12709)
+++ issm/trunk/src/modules/StringToEnum/StringToEnum.h	(revision 13395)
@@ -6,7 +6,16 @@
 #define _STRINGTOENUM_H
 
-/* local prototypes: */
-void StringToEnumUsage(void);
+#ifdef HAVE_CONFIG_H
+	#include <config.h>
+#else
+	#error "Cannot compile with HAVE_CONFIG_H symbol! run configure first!"
+#endif
 
+/*For python modules: needs to come before header files inclusion*/
+#ifdef _HAVE_PYTHON_
+#define PY_ARRAY_UNIQUE_SYMBOL PythonIOSymbol
+#endif
+
+/*Header files: */
 #include "../../c/include/globals.h"
 #include "../../c/modules/modules.h"
@@ -14,10 +23,21 @@
 #include "../../c/shared/shared.h"
 #include "../../c/issm-binding.h"
+
+#undef __FUNCT__ 
+#define __FUNCT__  "StringToEnum"
     
+#ifdef _HAVE_MATLAB_MODULES_
 /* serial input macros: */
 #define NAME (mxArray*)prhs[0]
-
 /* serial output macros: */
 #define ENUMOUT (mxArray**)&plhs[0]
+#endif
+
+#ifdef _HAVE_PYTHON_MODULES_
+/* serial input macros: */
+#define NAME PyTuple_GetItem(args,0)
+/* serial output macros: */
+#define ENUMOUT output,0
+#endif
 
 /* serial arg counts: */
@@ -27,6 +47,3 @@
 #define NRHS  1
 
-#undef __FUNCT__ 
-#define __FUNCT__  "StringToEnum"
-
 #endif  /* _TEST_H */
Index: issm/trunk/src/modules/TriMesh/TriMesh.cpp
===================================================================
--- issm/trunk/src/modules/TriMesh/TriMesh.cpp	(revision 12709)
+++ issm/trunk/src/modules/TriMesh/TriMesh.cpp	(revision 13395)
@@ -5,21 +5,26 @@
 #include "./TriMesh.h"
 
+void TriMeshUsage(void){/*{{{*/
+	_printLine_("");
+	_printLine_("   usage: [index,x,y,segments,segmentmarkers]=TriMesh(domainoutlinefilename,rifts,area) ");
+	_printLine_("      where: index,x,y defines a triangulation, segments is an array made ");
+	_printLine_("      of exterior segments to the mesh domain outline, segmentmarkers is an array flagging each segment, ");
+	_printLine_("      outlinefilename an Argus domain outline file, ");
+	_printLine_("      area is the maximum area desired for any element of the resulting mesh, ");
+	_printLine_("");
+}/*}}}*/
 WRAPPER(TriMesh){
 	
-	/* input: */
-	char   *domainname = NULL;
-	char   *riftsname  = NULL;
+	/*intermediary: */
 	double  area;
-
-	/*intermediary: */
 	DataSet *domain = NULL;
 	DataSet *rifts  = NULL;
 
 	/* output: */
-	Matrix *index             = NULL;
-	Vector *x                 = NULL;
-	Vector *y                 = NULL;
-	Matrix *segments          = NULL;
-	Vector *segmentmarkerlist = NULL;
+	SeqMat<double> *index             = NULL;
+	SeqVec<double> *x                 = NULL;
+	SeqVec<double> *y                 = NULL;
+	SeqMat<double> *segments          = NULL;
+	SeqVec<double> *segmentmarkerlist = NULL;
 
 	/*Boot module: */
@@ -30,11 +35,7 @@
 	
 	/*Fetch data needed for meshing: */
-	FetchData(&domainname,DOMAINOUTLINE);
-	FetchData(&riftsname,RIFTSOUTLINE);
+	FetchData(&domain,DOMAINOUTLINE);
+	FetchData(&rifts,RIFTSOUTLINE);
 	FetchData(&area,AREA);
-
-	/*Read domain outline: */
-	domain = DomainOutlineRead(domainname);
-	rifts  = DomainOutlineRead(riftsname);
 
 	/*call x core: */
@@ -51,23 +52,11 @@
 	delete domain;
 	delete rifts;
-	xdelete_module(&index);
-	xdelete_module(&x);
-	xdelete_module(&y);
-	xdelete_module(&segments);
-	xdelete_module(&segmentmarkerlist);
+	delete index;
+	delete x;
+	delete y;
+	delete segments;
+	delete segmentmarkerlist;
 
 	/*end module: */
 	MODULEEND();
 }
-
-void TriMeshUsage(void) //{{{1
-{
-	_printLine_("");
-	_printLine_("   usage: [index,x,y,segments,segmentmarkers]=TriMesh(domainoutlinefilename,rifts,area) ");
-	_printLine_("      where: index,x,y defines a triangulation, segments is an array made ");
-	_printLine_("      of exterior segments to the mesh domain outline, segmentmarkers is an array flagging each segment, ");
-	_printLine_("      outlinefilename an Argus domain outline file, ");
-	_printLine_("      area is the maximum area desired for any element of the resulting mesh, ");
-	_printLine_("");
-}
-//}}}
Index: issm/trunk/src/modules/TriMesh/TriMesh.h
===================================================================
--- issm/trunk/src/modules/TriMesh/TriMesh.h	(revision 12709)
+++ issm/trunk/src/modules/TriMesh/TriMesh.h	(revision 13395)
@@ -9,8 +9,8 @@
 	#include <config.h>
 #else
-#error "Cannot compile with HAVE_CONFIG_H symbol! run configure first!"
+	#error "Cannot compile with HAVE_CONFIG_H symbol! run configure first!"
 #endif
 
-/*Very important definition in case we are compiling a python module!: needs to come before header files inclusion*/
+/*For python modules: needs to come before header files inclusion*/
 #ifdef _HAVE_PYTHON_
 #define PY_ARRAY_UNIQUE_SYMBOL PythonIOSymbol
@@ -28,9 +28,12 @@
 #include "../../c/EnumDefinitions/EnumDefinitions.h"
 
+#undef __FUNCT__ 
+#define __FUNCT__  "TriMesh"
+
 #ifdef _HAVE_MATLAB_MODULES_
 /* serial input macros: */
-#define DOMAINOUTLINE  (mxArray *)prhs[0]
-#define RIFTSOUTLINE   (mxArray *)prhs[1]
-#define AREA           (mxArray *)prhs[2]
+#define DOMAINOUTLINE  prhs[0]
+#define RIFTSOUTLINE   prhs[1]
+#define AREA           prhs[2]
 /* serial output macros: */
 #define INDEX             (mxArray**)&plhs[0]
@@ -54,7 +57,4 @@
 #endif
 
-#undef __FUNCT__ 
-#define __FUNCT__  "TriMesh"
-
 /* serial arg counts: */
 #undef NLHS
@@ -63,6 +63,3 @@
 #define NRHS  3
 
-/* local prototypes: */
-void TriMeshUsage(void);
-
 #endif  /* _TRIMESH_H */
Index: issm/trunk/src/modules/TriMeshProcessRifts/TriMeshProcessRifts.cpp
===================================================================
--- issm/trunk/src/modules/TriMeshProcessRifts/TriMeshProcessRifts.cpp	(revision 12709)
+++ issm/trunk/src/modules/TriMeshProcessRifts/TriMeshProcessRifts.cpp	(revision 13395)
@@ -5,23 +5,27 @@
 #include "./TriMeshProcessRifts.h"
 
-void mexFunction(	int nlhs, mxArray* plhs[],
-					int nrhs, const mxArray* prhs[] ) {
-
+void TriMeshProcessRiftsUsage(void){/*{{{*/
+	_printLine_("");
+	_printLine_("   usage: [index2,x2,y2,segments2,segmentmarkers2,rifts2]=TriMeshProcessrifts(index1,x1,y1,segments1,segmentmarkers1) ");
+	_printLine_("      where: (index1,x1,y1,segments1,segmentmarkers1) is an initial triangulation.");
+	_printLine_("      index2,x2,y2,segments2,segmentmarkers2,rifts2 is the resulting triangulation where rifts have been processed.");
+}/*}}}*/
+WRAPPER(TriMeshProcessRifts){
 
 	/*Matlab arrays: */
-	mxArray* pmxa_array=NULL;
-	mxArray* pmxa_array2=NULL;
-	mxArray* pmxa_array3=NULL;
+	mxArray *pmxa_array  = NULL;
+	mxArray *pmxa_array2 = NULL;
+	mxArray *pmxa_array3 = NULL;
 	int i,j,k,counter;
 	
 	/* returned quantities: */
 	int      out_numrifts;
-	int*     out_riftsnumsegments=NULL;
-	double** out_riftssegments=NULL; 
-	int*     out_riftsnumpairs=NULL;
-	double** out_riftspairs=NULL;
-	double*  out_riftstips=NULL;
-	double** out_riftspenaltypairs=NULL;
-	int*     out_riftsnumpenaltypairs=NULL;
+	int     *out_riftsnumsegments     = NULL;
+	double **out_riftssegments        = NULL;
+	int     *out_riftsnumpairs        = NULL;
+	double **out_riftspairs           = NULL;
+	double  *out_riftstips            = NULL;
+	double **out_riftspenaltypairs    = NULL;
+	int     *out_riftsnumpenaltypairs = NULL;
 
 	/*empty rifts structure: */
@@ -34,20 +38,19 @@
 	
 	/* input: */
-	double* tindex_in=NULL;
-	double* index_in=NULL;
+	double *tindex_in = NULL;
+	double *index_in  = NULL;
 	int     nel;
-	double* x_inm=NULL; //matlab vector
-	double* x_in=NULL; //copy of matlab vector
+	double *x_inm = NULL; //matlab vector
+	double *x_in  = NULL; //copy of matlab vector
 	int     nods;
-	double* y_inm=NULL;//matlab vector
-	double* y_in=NULL;//copy of matlab vector
-	double* tsegments_in=NULL;
-	double* segments_in=NULL;
-	double* tsegmentmarkers_in=NULL;
-	double* segmentmarkers_in=NULL;
+	double *y_inm              = NULL; //matlab vector
+	double *y_in               = NULL; //copy of matlab vector
+	double *tsegments_in       = NULL;
+	double *segments_in        = NULL;
+	double *tsegmentmarkers_in = NULL;
+	double *segmentmarkers_in  = NULL;
 
 	/* state: */
-	double* state=NULL;
-
+	double *state = NULL;
 	int     num_seg;
 
@@ -57,5 +60,5 @@
 
 	/* verify correct usage: */
-	if (nlhs==0 && nrhs==0) {
+	if (nlhs==0 && nrhs==0){
 		/* special case: */
 		TriMeshProcessRiftsUsage();
@@ -73,5 +76,5 @@
 		nel=mxGetM(prhs[0]);
 		tindex_in=mxGetPr(prhs[0]);
-		index_in=(double*)xmalloc(nel*3*sizeof(double));
+		index_in=xNew<double>(nel*3);
 		for (i=0;i<nel;i++){
 			for (j=0;j<3;j++){
@@ -88,5 +91,5 @@
 		nods=mxGetM(prhs[1]);
 		x_inm=mxGetPr(prhs[1]);
-		x_in=(double*)xmalloc(nods*sizeof(double));
+		x_in=xNew<double>(nods);
 		for (i=0;i<nods;i++){
 			x_in[i]=x_inm[i];
@@ -100,5 +103,5 @@
 	if(mxIsDouble(prhs[2])){
 		y_inm=mxGetPr(prhs[2]);
-		y_in=(double*)xmalloc(nods*sizeof(double));
+		y_in=xNew<double>(nods);
 		for (i=0;i<nods;i++){
 			y_in[i]=y_inm[i];
@@ -113,5 +116,5 @@
 		num_seg=mxGetM(prhs[3]);
 		tsegments_in=mxGetPr(prhs[3]);
-		segments_in=(double*)xmalloc(num_seg*3*sizeof(double));
+		segments_in=xNew<double>(num_seg*3);
 		for (i=0;i<num_seg;i++){
 			for (j=0;j<3;j++){
@@ -127,5 +130,5 @@
 	if(mxIsDouble(prhs[4])){
 		tsegmentmarkers_in=mxGetPr(prhs[4]);
-		segmentmarkers_in=(double*)xmalloc(num_seg*sizeof(double));
+		segmentmarkers_in=xNew<double>(num_seg);
 		for (i=0;i<num_seg;i++){
 			segmentmarkers_in[i]=tsegmentmarkers_in[i];
@@ -169,41 +172,11 @@
 	/*Output : */
 	WriteData(&plhs[0],index_in,nel,3);
-	//pmxa_array= mxCreateDoubleMatrix(0,0,mxREAL);
-	//mxSetM(pmxa_array,3);
-	//mxSetN(pmxa_array,nel);
-	//mxSetPr(pmxa_array,index_in);
-	//mexCallMATLAB( 1, &plhs[0], 1, &pmxa_array, "transpose");
-
 	WriteData(&plhs[1],x_in,nods,1);
-	//pmxa_array= mxCreateDoubleMatrix(0,0,mxREAL);
-	//mxSetM(pmxa_array,1);
-	//mxSetN(pmxa_array,nods);
-	//mxSetPr(pmxa_array,x_in);
-	//mexCallMATLAB( 1, &plhs[1], 1, &pmxa_array, "transpose");
-
 	WriteData(&plhs[2],y_in,nods,1);
-	//pmxa_array= mxCreateDoubleMatrix(0,0,mxREAL);
-	//mxSetM(pmxa_array,1);
-	//mxSetN(pmxa_array,nods);
-	//mxSetPr(pmxa_array,y_in);
-	//mexCallMATLAB( 1, &plhs[2], 1, &pmxa_array, "transpose");
-
 	WriteData(&plhs[3],segments_in,num_seg,3);
-//pmxa_array= mxCreateDoubleMatrix(0,0,mxREAL);
-//mxSetM(pmxa_array,3);
-//mxSetN(pmxa_array,num_seg);
-//mxSetPr(pmxa_array,segments_in);
-//mexCallMATLAB( 1, &plhs[3], 1, &pmxa_array, "transpose");
-
 	WriteData(&plhs[4],segmentmarkers_in,num_seg,1);
-	//pmxa_array= mxCreateDoubleMatrix(0,0,mxREAL);
-	//mxSetM(pmxa_array,1);
-	//mxSetN(pmxa_array,num_seg);
-	//mxSetPr(pmxa_array,segmentmarkers_in);
-	//mexCallMATLAB( 1, &plhs[4], 1, &pmxa_array, "transpose");
 
 	if(riftflag){
 		/*Create a structure rifts where if i is a rift number, we have the following fields rifts(i).segments and rifts(i).numsegs: */
-
 		fnames[0] = "numsegs";
 		fnames[1] = "segments";
@@ -225,9 +198,4 @@
 			/*Segments: */
 			WriteData(&pmxa_array3,out_riftssegments[i],out_riftsnumsegments[i],3);
-			//pmxa_array2= mxCreateDoubleMatrix(0,0,mxREAL);
-			//mxSetM(pmxa_array2,3);
-			//mxSetN(pmxa_array2,out_riftsnumsegments[i]);
-			//mxSetPr(pmxa_array2,out_riftssegments[i]);
-			//mexCallMATLAB( 1, &pmxa_array3, 1, &pmxa_array2, "transpose");
 			mxSetField(pmxa_array,i,"segments",pmxa_array3);
 			mxSetField(pmxa_array,i,"numsegs",mxCreateDoubleScalar((double)out_riftsnumsegments[i]));
@@ -235,9 +203,4 @@
 			/*Element pairs: */
 			WriteData(&pmxa_array3,out_riftspairs[i],out_riftsnumpairs[i],2);
-			//pmxa_array2= mxCreateDoubleMatrix(0,0,mxREAL);
-			//mxSetM(pmxa_array2,2);
-			//mxSetN(pmxa_array2,out_riftsnumpairs[i]);
-			//mxSetPr(pmxa_array2,out_riftspairs[i]);
-			//mexCallMATLAB( 1, &pmxa_array3, 1, &pmxa_array2, "transpose");
 			mxSetField(pmxa_array,i,"pairs",pmxa_array3);
 
@@ -254,9 +217,4 @@
 			/*Penalty pairs: */
 			WriteData(&pmxa_array3,out_riftspenaltypairs[i],out_riftsnumpenaltypairs[i],7);
-			//pmxa_array2= mxCreateDoubleMatrix(0,0,mxREAL);
-			//mxSetM(pmxa_array2,7);
-			//mxSetN(pmxa_array2,out_riftsnumpenaltypairs[i]);
-			//mxSetPr(pmxa_array2,out_riftspenaltypairs[i]);
-			//mexCallMATLAB( 1, &pmxa_array3, 1, &pmxa_array2, "transpose");
 			mxSetField(pmxa_array,i,"penaltypairs",pmxa_array3);
 
@@ -293,11 +251,2 @@
 	return;
 }
-
-
-void TriMeshProcessRiftsUsage(void)
-{
-	_printLine_("");
-	_printLine_("   usage: [index2,x2,y2,segments2,segmentmarkers2,rifts2]=TriMeshProcessrifts(index1,x1,y1,segments1,segmentmarkers1) ");
-	_printLine_("      where: (index1,x1,y1,segments1,segmentmarkers1) is an initial triangulation.");
-	_printLine_("      index2,x2,y2,segments2,segmentmarkers2,rifts2 is the resulting triangulation where rifts have been processed.");
-}
Index: issm/trunk/src/modules/TriMeshProcessRifts/TriMeshProcessRifts.h
===================================================================
--- issm/trunk/src/modules/TriMeshProcessRifts/TriMeshProcessRifts.h	(revision 12709)
+++ issm/trunk/src/modules/TriMeshProcessRifts/TriMeshProcessRifts.h	(revision 13395)
@@ -9,5 +9,4 @@
 #include "triangle.h"
 #include "string.h"
-
 #include "../../c/include/globals.h"
 #include "../../c/modules/modules.h"
@@ -17,5 +16,4 @@
 #include "../../c/EnumDefinitions/EnumDefinitions.h"
 
-void TriMeshProcessRiftsUsage(void);
 #undef __FUNCT__ 
 #define __FUNCT__ "TriMeshProcessRifts"
Index: issm/trunk/src/modules/TriaSearch/TriaSearch.cpp
===================================================================
--- issm/trunk/src/modules/TriaSearch/TriaSearch.cpp	(revision 12709)
+++ issm/trunk/src/modules/TriaSearch/TriaSearch.cpp	(revision 13395)
@@ -4,5 +4,15 @@
 #include "./TriaSearch.h"
 
-void mexFunction( int nlhs, mxArray* plhs[], int nrhs, const mxArray* prhs[]){
+void TriaSearchUsage(void){/*{{{*/
+	_pprintLine_("TriaSearch- find triangle holding a point (x0,y0) in a mesh");
+	_pprintLine_("");
+	_pprintLine_("   Usage:");
+	_pprintLine_("         tria=TriaSearch(index,x,y,x0,y0);");
+	_pprintLine_("      index,x,y: mesh triangulatrion");
+	_pprintLine_("      x0,y0: coordinates of the point for which we are trying to find a triangle");
+	_pprintLine_("      x0,y0 can be an array of points");
+	_pprintLine_("");
+}/*}}}*/
+WRAPPER(TriaSearch){
 
 	int i;
@@ -49,13 +59,2 @@
 	MODULEEND();
 }
-
-void TriaSearchUsage(void){
-	_pprintLine_("TriaSearch- find triangle holding a point (x0,y0) in a mesh");
-	_pprintLine_("");
-	_pprintLine_("   Usage:");
-	_pprintLine_("         tria=TriaSearch(index,x,y,x0,y0);");
-	_pprintLine_("      index,x,y: mesh triangulatrion");
-	_pprintLine_("      x0,y0: coordinates of the point for which we are trying to find a triangle");
-	_pprintLine_("      x0,y0 can be an array of points");
-	_pprintLine_("");
-}
Index: issm/trunk/src/modules/TriaSearch/TriaSearch.h
===================================================================
--- issm/trunk/src/modules/TriaSearch/TriaSearch.h	(revision 12709)
+++ issm/trunk/src/modules/TriaSearch/TriaSearch.h	(revision 13395)
@@ -5,6 +5,14 @@
 #define _TRIASEARCH_H
 
-/* local prototypes: */
-void TriaSearchUsage(void);
+#ifdef HAVE_CONFIG_H
+	#include <config.h>
+#else
+	#error "Cannot compile with HAVE_CONFIG_H symbol! run configure first!"
+#endif
+
+/*For python modules: needs to come before header files inclusion*/
+#ifdef _HAVE_PYTHON_
+#define PY_ARRAY_UNIQUE_SYMBOL PythonIOSymbol
+#endif
 
 #include "../../c/include/globals.h"
@@ -17,19 +25,31 @@
 #define __FUNCT__  "TriaSearch"
 
-
+#ifdef _HAVE_MATLAB_MODULES_
 /* serial input macros: */
 #define INDEXHANDLE prhs[0]
-#define XHANDLE prhs[1]
-#define YHANDLE prhs[2]
-#define X0HANDLE prhs[3]
-#define Y0HANDLE prhs[4]
+#define XHANDLE     prhs[1]
+#define YHANDLE     prhs[2]
+#define X0HANDLE    prhs[3]
+#define Y0HANDLE    prhs[4]
 
 /* serial output macros: */
 #define TRIA (mxArray**)&plhs[0]
+#endif
+
+#ifdef _HAVE_PYTHON_MODULES_
+/* serial input macros: */
+#define INDEXHANDLE PyTuple _GetItem(args,0)
+#define XHANDLE     PyTuple _GetItem(args,1)
+#define YHANDLE     PyTuple _GetItem(args,2)
+#define X0HANDLE    PyTuple _GetItem(args,3)
+#define Y0HANDLE    PyTuple _GetItem(args,4)
+
+/* serial output macros: */
+#define TRIA output,0
+#endif
 
 /* serial arg counts: */
 #undef NLHS
 #define NLHS  1
-
 #undef NRHS
 #define NRHS  5
Index: issm/trunk/src/modules/Xy2ll/Xy2ll.cpp
===================================================================
--- issm/trunk/src/modules/Xy2ll/Xy2ll.cpp	(revision 12709)
+++ issm/trunk/src/modules/Xy2ll/Xy2ll.cpp	(revision 13395)
@@ -4,73 +4,5 @@
 #include "./Xy2ll.h"
 
-void mexFunction( int nlhs, mxArray* plhs[], int nrhs, const mxArray* prhs[]){
-
-	int i,verbose=1;
-
-	/*input: */
-	double  *x=NULL,*y=NULL;
-	int     nx,ny,ncoord;
-	int     sgn;
-	Options* options=NULL;
-	double   cm=0.,sp=0.;
-
-	/* output: */
-	double  *lat=NULL,*lon=NULL;
-	int     iret=0;
-
-	/*Boot module: */
-	MODULEBOOT();
-
-	/*checks on arguments on the matlab side: */
-	if (nlhs > NLHS) {
-		Xy2llUsage(); _error2_("Xy2ll usage error");
-	}
-	if (nrhs < NRHS) {
-		Xy2llUsage(); _error2_("Xy2ll usage error");
-	}
-
-	/*Input datasets: */
-	FetchData(&x,&nx,X_IN);
-	FetchData(&y,&ny,Y_IN);
-	FetchData(&sgn,SGN_IN);
-	FetchData(&options,NRHS,nrhs,prhs);
-
-	/*  defaults are in Xy2lldef, so don't duplicate them here, and only use user values if both have been specified  */
-	if (options->GetOption("central_meridian") || options->GetOption("standard_parallel")) {
-		options->Get(&cm,"central_meridian");
-		if (verbose) _printLine_("  cm=" << cm);
-		options->Get(&sp,"standard_parallel");
-		if (verbose) _printLine_("  sp=" << sp);
-	}
-
-	/*some checks*/
-	if   (nx != ny){_error2_("Must have same number of x[" << nx << "] and y[" << ny << "] coordinates.");}
-	else            ncoord=nx;
-	if (sgn != +1 && sgn != -1) _error2_("Hemisphere sgn=" << sgn << " must be +1 (north) or -1 (south).");
-	if (fabs(cm)      > 180.) _error2_("Central meridian cm=" << cm << " must be between -180 (west) and +180 (east) degrees.");
-	if (sp < 0. || sp >  90.) _error2_("Standard parallel sp=" << sp << " must be between 0 and 90 degrees (in specified hemisphere).");
-
-	lat=(double*)mxMalloc(ncoord*sizeof(double));
-	lon=(double*)mxMalloc(ncoord*sizeof(double));
-
-	/* Run core computations: */
-	if (verbose) _printLine_("Calling core:");
-	if (options->GetOption("central_meridian") && options->GetOption("standard_parallel"))
-		iret=Xy2llx(lat,lon,x,y,ncoord,sgn,cm,sp);
-	else
-		iret=Xy2llx(lat,lon,x,y,ncoord,sgn);
-
-	/*Write data: */
-	WriteData(LAT_OUT,lat,ncoord);
-	WriteData(LON_OUT,lon,ncoord);
-
-	/*Clean-up*/
-	delete options;
-
-	/*end module: */
-	MODULEEND();
-}
-
-void Xy2llUsage(void){
+void Xy2llUsage(void){/*{{{*/
 	_pprintLine_("Xy2ll - x/y to lat/long coordinate transformation module:");
 	_pprintLine_("");
@@ -95,4 +27,70 @@
 	_pprintLine_("      [lat,lon]=Xy2ll(x,y,-1,'central_meridian', 0,'standard_parallel',71);");
 	_pprintLine_("");
+}/*}}}*/
+WRAPPER(Xy2ll){
+
+	int i,verbose=1;
+
+	/*input: */
+	double  *x=NULL,*y=NULL;
+	int     nx,ny,ncoord;
+	int     sgn;
+	Options* options=NULL;
+	double   cm=0.,sp=0.;
+
+	/* output: */
+	double  *lat=NULL,*lon=NULL;
+	int     iret=0;
+
+	/*Boot module: */
+	MODULEBOOT();
+
+	/*checks on arguments on the matlab side: */
+	if (nlhs > NLHS) {
+		Xy2llUsage(); _error_("Xy2ll usage error");
+	}
+	if (nrhs < NRHS) {
+		Xy2llUsage(); _error_("Xy2ll usage error");
+	}
+
+	/*Input datasets: */
+	FetchData(&x,&nx,X_IN);
+	FetchData(&y,&ny,Y_IN);
+	FetchData(&sgn,SGN_IN);
+	FetchData(&options,NRHS,nrhs,prhs);
+
+	/*  defaults are in Xy2lldef, so don't duplicate them here, and only use user values if both have been specified  */
+	if (options->GetOption("central_meridian") || options->GetOption("standard_parallel")) {
+		options->Get(&cm,"central_meridian");
+		if (verbose) _printLine_("  cm=" << cm);
+		options->Get(&sp,"standard_parallel");
+		if (verbose) _printLine_("  sp=" << sp);
+	}
+
+	/*some checks*/
+	if   (nx != ny){_error_("Must have same number of x[" << nx << "] and y[" << ny << "] coordinates.");}
+	else            ncoord=nx;
+	if (sgn != +1 && sgn != -1) _error_("Hemisphere sgn=" << sgn << " must be +1 (north) or -1 (south).");
+	if (fabs(cm)      > 180.) _error_("Central meridian cm=" << cm << " must be between -180 (west) and +180 (east) degrees.");
+	if (sp < 0. || sp >  90.) _error_("Standard parallel sp=" << sp << " must be between 0 and 90 degrees (in specified hemisphere).");
+
+	lat=(double*)mxMalloc(ncoord*sizeof(double));
+	lon=(double*)mxMalloc(ncoord*sizeof(double));
+
+	/* Run core computations: */
+	if (verbose) _printLine_("Calling core:");
+	if (options->GetOption("central_meridian") && options->GetOption("standard_parallel"))
+		iret=Xy2llx(lat,lon,x,y,ncoord,sgn,cm,sp);
+	else
+		iret=Xy2llx(lat,lon,x,y,ncoord,sgn);
+
+	/*Write data: */
+	WriteData(LAT_OUT,lat,ncoord);
+	WriteData(LON_OUT,lon,ncoord);
+
+	/*Clean-up*/
+	delete options;
+
+	/*end module: */
+	MODULEEND();
 }
-
